#include <iostream>
#include <cstdlib>

using namespace std;

int main()
{
    int n;
    int o, a, b, ab;
    
    cin >> n;
    cin >> o >> a >> b >> ab;
    
    string krvna_grupa[n];
    int potrebna_kolicina[n];
    int broj1[n], broj2[n], broj3[n], broj4[n];
    
    for(int i = 0; i < n; i++)
    {
        cin >> krvna_grupa[i] >> potrebna_kolicina[i];
    }
    
    for(int i = 0; i < n; i++)
    {
        if(krvna_grupa[i]=="A")
        {
            a -=potrebna_kolicina[i];
            
            if(a < 0)
            {
                o -=abs(a);
                
                if(o < 0)
                {
                    cout << "nemoguce";
                    goto end;
                }
                broj1[i] = abs(a);
                broj2[i] = potrebna_kolicina[i]-abs(a);
                broj3[i] = 0;
                broj4[i] = 0;
                continue;
            }
            broj1[i] = 0;
            broj2[i] = potrebna_kolicina[i];
            broj3[i] = 0;
            broj4[i] = 0;
            continue;
        }
        
        else if(krvna_grupa[i]=="B")
        {
            b -=potrebna_kolicina[i];
            
            if(b < 0)
            {
                o -=abs(b);
                
                if(o < 0)
                {
                    cout << "nemoguce";
                    goto end;
                }
                broj1[i] = abs(b);
                broj2[i] = 0;
                broj3[i] = potrebna_kolicina[i]-abs(b);
                broj4[i] = 0;
                continue;
            }
            broj1[i] = 0;
            broj2[i] = 0;
            broj3[i] = potrebna_kolicina[i];
            broj4[i] = 0;
            continue;
        }
        
        else if(krvna_grupa[i]=="O")
        {
            o -=potrebna_kolicina[i];
            
            if(o < 0)
            {
                cout << "nemoguce";
                goto end;
            }
            broj1[i] = potrebna_kolicina[i];
            broj2[i] = 0;
            broj3[i] = 0;
            broj4[i] = 0;
            continue;
        }
    }
    
    cout << "moguce" << endl;
    for(int i = 0; i < n; i++)
    {
        cout << broj1[i] << " " << broj2[i] << " " << broj3[i] << " " << broj4[i] << endl;
    }
    
    end:
    return 0;
}